// Guillaume DEWISME & Axel ELIAS - FISA TI 2027
package org.example;

import org.example.items.Item;

import java.util.Random;
import java.util.Scanner;

import static org.example.BeatThemAllGame.chooseHero;
import static org.example.BeatThemAllGame.generateRandomEnemy;
import static org.example.BeatThemAllGame.getRandomItem;

public class Main {

    public static void main(String[] args) {
        Test.runTests();
        Scanner scanner = new Scanner(System.in);
        BeatThemAllGame.displayTitle();

        Hero hero = chooseHero(scanner);
        System.out.println();

        System.out.println("Votre aventure commence !");
        Logger.getInstance().log("Début de l'aventure de " + hero.name);

        boolean gameRunning = true;
        while (gameRunning && hero.isAlive()) {
            Enemy enemy = generateRandomEnemy();
            System.out.println("\nUn " + enemy.name + " apparaît !");
            Logger.getInstance().log(hero.name + " rencontre un " + enemy.name);
            Battle.battle(scanner, hero, enemy);
            if (!hero.isAlive()) {
                BeatThemAllGame.displayGameOver();
                Logger.getInstance().log(hero.name + " est mort");
                break;
            }
            hero.resetSpecialAbility();
            hero.gainExperience(50);

            // Chance de trouver un objet après le combat
            if (new Random().nextInt(2) == 1) {
                Item foundItem = getRandomItem();
                System.out.println("Vous trouvez un objet sur l'ennemi !");
                hero.addItem(foundItem);
            }

            // Demander au joueur si il veut continuer
            System.out.print("\nVoulez-vous continuer ? (oui/non) : ");
            String choice;
            while (true) {
                choice = scanner.nextLine().trim().toLowerCase(); // On normalise la saisie

                // Vérifie si la saisie est valide
                if (choice.equals("oui") || choice.equals("o")) {
                    break; // Quitte la boucle si la saisie est valide
                } else if (choice.equals("non") || choice.equals("n")) {
                    gameRunning = false;
                    System.out.println("Merci d'avoir joué !");
                    Logger.getInstance().log(hero.name + " a quitté le jeu");
                    break;

                } else {
                    System.out.println("Saisie invalide, veuillez entrer 'oui', 'o', 'non' ou 'n' :");
                }
            }
        }
    }
}